package exer08;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.sql.*;

public class Servlet01 extends HttpServlet {
	Connection co;
	PreparedStatement selectps;
	PreparedStatement insertps;
	PreparedStatement deleteps;

	private void getConnection() throws Exception {
		ResourceBundle rb = ResourceBundle.getBundle("postgresql");
		Class.forName(rb.getString("driver"));
		String jdbc = rb.getString("jdbc");
		String dtbs = rb.getString("dtbs");
		String user = rb.getString("user");
		String pass = rb.getString("pass");
		co = DriverManager.getConnection(jdbc + dtbs, user, pass);
		selectps = co.prepareStatement("select * from playerslist");
		insertps = co.prepareStatement("insert into playerslist values(?,?,?,?,?)");
		deleteps = co.prepareStatement("delete from playerslist where back=?");
	}

	private void close(){
		try{
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		try{
			getConnection();
			req.setCharacterEncoding("UTF-8");
			String ope = req.getParameter("ope");
			if(ope.equals("select")){
				ResultSet rs = selectps.executeQuery();
				List ll = new LinkedList();
				while(rs.next()){
					String[] row = new String[5];
					row[0] = rs.getString("back");
					row[1] = rs.getString("name");
					row[2] = rs.getString("nation");
					row[3] = rs.getString("height");
					row[4] = rs.getString("weight");
					ll.add(row);
				}
				req.setAttribute("player01", ll);
				req.getRequestDispatcher("/exer08/Show01.jsp").forward(req, res);
			}else if(ope.equals("insert")){
				insertps.setString(1, req.getParameter("back"));
				insertps.setString(2, req.getParameter("name"));
				insertps.setString(3, req.getParameter("nation"));
				insertps.setString(4, req.getParameter("height"));
				insertps.setString(5, req.getParameter("weight"));
				insertps.executeUpdate();
				res.sendRedirect("/exercise/exer08/Insert01.html");
			}else if(ope.equals("delete")){
				deleteps.setString(1, req.getParameter("back"));
				deleteps.executeUpdate();
				res.sendRedirect("/exercise/exer08/Delete01.html");
			}
		}catch(Exception ex){
			ex.printStackTrace();
			throw new ServletException(ex);
		}finally{
			close();
		}
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		doGet(req, res);
	}
}
