package datasource;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;

public class Gender02 extends HttpServlet {
	Connection co;
	PreparedStatement ps;

	private void getConnection() throws Exception {
		InitialContext ic = new InitialContext();
		DataSource ds = (DataSource)ic.lookup("java:comp/env/jdbc/postgresql");
		co = ds.getConnection();
		ps = co.prepareStatement("select * from memberlist");
	}

	private void close(){
		try{
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		try{
			getConnection();
			req.setCharacterEncoding("UTF-8");
			String[] values = req.getParameterValues("gender");
			if(values != null){
				int flag = 0;
				for(int i = 0; i < values.length; i++){
					flag += Integer.parseInt(values[i]);
				}
				ResultSet rs = ps.executeQuery();
				List ll = new LinkedList();
				while(rs.next()){
					String gender = rs.getString("gender");
					if((flag & Integer.parseInt(gender)) == 0){
						continue;
					}
					String[] row = new String[5];
					row[0] = rs.getString("id");
					row[1] = rs.getString("name");
					row[2] = gender.equals("1") ? "男" : "女";
					row[3] = rs.getString("tel");
					row[4] = rs.getString("email");
					ll.add(row);
				}
				req.setAttribute("memberlist", ll);
			}
			req.getRequestDispatcher("/datasource/Gender02.jsp").forward(req, res);
		}catch(Exception ex){
			ex.printStackTrace();
			throw new ServletException(ex);
		}finally{
			close();
		}
	}
}
