package datasource;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;

public class SQLExec01 extends HttpServlet {
	Connection co;
	Statement st;

	private void getConnection() throws Exception {
		InitialContext ic = new InitialContext();
		DataSource ds = (DataSource)ic.lookup("java:comp/env/jdbc/postgresql");
		co = ds.getConnection();
		st = co.createStatement();
	}

	private void close(){
		try{
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		try{
			getConnection();
			req.setCharacterEncoding("UTF-8");
			String sql = (String)req.getAttribute("sql");
			boolean flag = st.execute(sql);
			if(flag){
				ResultSet rs = st.getResultSet();
				ResultSetMetaData rsmd = rs.getMetaData();
				int cnt = rsmd.getColumnCount();
				List ll = new LinkedList();
				while(rs.next()){
					String[] row = new String[cnt];
					for(int i = 0; i < row.length; i++){
						row[i] = rs.getString(i + 1);
					}
					ll.add(row);
				}
				req.setAttribute("memberlist", ll);
			}else{
				int updcnt = st.getUpdateCount();
				req.setAttribute("updatecount", Integer.toString(updcnt));
			}
		}catch(Exception ex){
			ex.printStackTrace();
			throw new ServletException(ex);
		}finally{
			close();
		}
	}
}
