package game;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;

public class Servlet01 extends HttpServlet {
	public class Info {
		String team = null;
		String court = null;
		Info opp = null;
		int move = -1;
		boolean reach = false;
		boolean check = false;

		public String getTeam(){return team;}
		public String getCourt(){return court;}
		public Info getOpp(){return opp;}
	}

	synchronized public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		boolean normal = false;

		req.setCharacterEncoding("UTF-8");
		ServletContext con = getServletContext();
		HashMap courts = (HashMap)con.getAttribute("courts");
		if(courts == null){
			courts = new HashMap();
			con.setAttribute("courts", courts);
		}
		HttpSession ses = req.getSession();
		Info self = (Info)ses.getAttribute("info");
		if(self == null){
			self = new Info();
			ses.setAttribute("info", self);
		}
		String ope = req.getParameter("ope");


		if(ope.equals("team")){
			normal = team(req, self);
			if(normal){
				res.sendRedirect("/jmwapp/game/Show01.jsp");
			}else{
				req.getRequestDispatcher("/game/Team01.jsp").forward(req, res);
			}
		}else if(ope.equals("court")){
			normal = court(req, self, courts, ses);
			if(normal){
				res.sendRedirect("/jmwapp/game/Show01.jsp");
			}else{
				req.getRequestDispatcher("/game/Court01.jsp").forward(req, res);
			}
		}else if(ope.equals("choice")){
			if(self.check){
				req.setAttribute("error", "相手がまだ前回の勝負をしていません");
				req.getRequestDispatcher("/game/Choice01.jsp").forward(req, res);
				return;
			}else if(self.opp != null && self.opp.check){
				req.setAttribute("error", "相手が既に勝負をしていますので、勝負ボタンをクリックして下さい。");
			}else{
				self.move = Integer.parseInt(req.getParameter("move"));
			}
			req.setAttribute("self_s", moveToStr(self.move));
			req.setAttribute("self_n", new Integer(self.move));
			req.getRequestDispatcher("/game/Fight01.jsp").forward(req, res);
		}else if(ope.equals("fight")){
			normal = fight(req, self);
			if(normal){
				req.getRequestDispatcher("/game/Result01.jsp").forward(req, res);
			}else{
				req.getRequestDispatcher("/game/Fight01.jsp").forward(req, res);
			}
		}else if(ope.equals("control")){
			Set keys = courts.keySet();
			HashMap courts_ = new HashMap();
			for(Iterator keyit = keys.iterator(); keyit.hasNext();){
				String key = (String)keyit.next();
				HashSet value = (HashSet)courts.get(key);
				LinkedList teams = new LinkedList();
				for(Iterator valit = value.iterator(); valit.hasNext();){
					teams.add(((Info)((HttpSession)valit.next()).getAttribute("info")).team);
				}
				courts_.put(key, teams);
			}
			req.setAttribute("courts", courts_);
			req.getRequestDispatcher("/game/Control01.jsp").forward(req, res);
		}
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		doGet(req, res);
	}

	private boolean team(HttpServletRequest req, Info self){
		String team = req.getParameter("team");
		if(team != null && !team.equals("")){
			if(self.opp != null && team.equals(self.opp.team)){
				req.setAttribute("error", "そのコートの先着チームと名前が重複しています");
				return false;
			}else{
				self.team = team;
				return true;
			}
		}else{
			req.setAttribute("error", "チーム名を入力して下さい");
			return false;
		}
	}

	private boolean court(HttpServletRequest req, Info self, HashMap courts, HttpSession ses){
		String court = req.getParameter("court");
		if(court != null && !court.equals("")){
			HashSet sess = (HashSet)courts.get(court);
			Info oldopp = self.opp;
			if(sess == null || sess.size() == 0){
				if(sess == null){
					sess = new HashSet();
					courts.put(court, sess);
				}
				self.opp = null;
			}else{
				if(court.equals(self.court)){
					return true;
				}else if(sess.size() == 2){
					req.setAttribute("error", "そのコートは既に２チーム決定しています");
					return false;
				}else{
					Info opp = (Info)((HttpSession)sess.iterator().next()).getAttribute("info");
					if(self.team != null && self.team.equals(opp.team)){
						req.setAttribute("error", "そのコートの先着チームと名前が重複しています");
						return false;
					}else{
						self.opp = opp;
						opp.opp = self;
					}
				}
			}
			if(self.court != null){
				((HashSet)courts.get(self.court)).remove(ses);
				if(oldopp != null){
					oldopp.opp = null;
				}
			}
			self.court = court;
			sess.add(ses);
			return true;
		}else{
			req.setAttribute("error", "コート名を入力して下さい");
			return false;
		}
	}

	private boolean fight(HttpServletRequest req, Info self){
		req.setAttribute("self_s", moveToStr(self.move));
		req.setAttribute("self_n", new Integer(self.move));
		String result = "エラー";
		if(self.move == -1){
			req.setAttribute("error", "あなたはまだ次の手を選択していません");
			return false;
		}else if(self.opp == null){
			req.setAttribute("error", "相手がまだいません");
			return false;
		}else if(self.opp.move == -1){
			req.setAttribute("error", "相手がまだ次の手を選択していません");
			return false;
		}else if(self.check){
			req.setAttribute("error", "相手がまだ前回の勝負をしていません");
			return false;
		}else if(self.move == self.opp.move){
			if(self.reach){
				result = "このゲームあなたの勝ちです";
			}else if(self.opp.reach){
				result = "このゲームあなたの負けです";
			}else{
				result = "どちらにもリーチはかかりませんでした";
			}
			if(self.opp.check){
				self.reach = self.opp.reach = false;
			}
		}else{
			if(win(self.move, self.opp.move)){
				self.reach = true;
				self.opp.reach = false;
				result = "あなたにリーチがかかりました";
			}else{
				self.reach = false;
				self.opp.reach = true;
				result = "相手にリーチがかかりました";
			}
		}
		req.setAttribute("opp_s", moveToStr(self.opp.move));
		req.setAttribute("opp_n", new Integer(self.opp.move));
		req.setAttribute("result", result);
		if(self.opp.check){
			self.check = self.opp.check = false;
			self.move = self.opp.move = -1;
		}else{
			self.check = true;
		}
		return true;
	}

	private String moveToStr(int move){
		switch(move){
		case 0: return "グー";
		case 2: return "チョキ";
		case 5: return "パー";
		default: return "未定";
		}
	}

	private boolean win(int self, int opp){
		switch(self){
		case 0:
			switch(opp){
			case 2: return true;
			case 5: return false;
			}
		case 2:
			switch(opp){
			case 0: return false;
			case 5: return true;
			}
		case 5:
			switch(opp){
			case 0: return true;
			case 2: return false;
			}
		default:
			return true;
		}
	}
}
