package goods;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.LinkedList;
import java.util.List;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Serv01 extends HttpServlet {
	Connection co;

	private void getConnection() throws Exception {
		ResourceBundle rb = ResourceBundle.getBundle("postgresql");
		Class.forName(rb.getString("driver"));
		String jdbc = rb.getString("jdbc");
		String dtbs = rb.getString("dtbs");
		String user = rb.getString("user");
		String pass = rb.getString("pass");
		co = DriverManager.getConnection(jdbc + dtbs, user, pass);
	}

	private void close(){
		try{
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws IOException, ServletException
	{
		try{
			req.setCharacterEncoding("UTF-8");
			String ope = req.getParameter("ope");
			getConnection();
			String sql;
			PreparedStatement ps;
			ResultSet rs;
			if(ope != null){
				if(ope.equals("insert")){
					sql = "insert into goodslist values(?,?,?,?)";
					ps = co.prepareStatement(sql);
					ps.setInt(1, Integer.parseInt(req.getParameter("code")));
					ps.setInt(2, Integer.parseInt(req.getParameter("cost")));
					ps.setInt(3, Integer.parseInt(req.getParameter("price")));
					ps.setString(4, req.getParameter("name"));
					ps.executeUpdate();
				}else if(ope.equals("delete")){
					sql = "delete from goodslist where code=?";
					ps = co.prepareStatement(sql);
					String[] delinfo = req.getParameterValues("delinfo");
					if(delinfo != null){
						for(int i = 0; i < delinfo.length; i++){
							ps.setInt(1, Integer.parseInt(delinfo[i]));
							ps.executeUpdate();
						}
					}
				}else if(ope.equals("updreq")){
					sql = "select * from goodslist where code=?";
					ps = co.prepareStatement(sql);
					ps.setInt(1, Integer.parseInt(req.getParameter("code")));
					rs = ps.executeQuery();
					rs.next();
					String[] row = {
						rs.getString("code"),
						rs.getString("cost"),
						rs.getString("price"),
						rs.getString("name")
					};
					req.setAttribute("row", row);
					req.getRequestDispatcher("/goods/Update01.jsp").forward(req, res);
					return;
				}else if(ope.equals("update")){
					sql = "update goodslist set cost=?, price=?, name=? where code=?";
					ps = co.prepareStatement(sql);
					ps.setInt(1, Integer.parseInt(req.getParameter("cost")));
					ps.setInt(2, Integer.parseInt(req.getParameter("price")));
					ps.setString(3, req.getParameter("name"));
					ps.setInt(4, Integer.parseInt(req.getParameter("code")));
					ps.executeUpdate();
				}
			}
			sql = "select * from goodslist";
			ps = co.prepareStatement(sql);
			rs = ps.executeQuery();
			List<String[]> ll = new LinkedList<String[]>();
			while(rs.next()){
				String[] row = {
					rs.getString("code"),
					rs.getString("cost"),
					rs.getString("price"),
					rs.getString("name")
				};
				ll.add(row);
			}
			req.setAttribute("goodslist", ll);
			req.getRequestDispatcher("/goods/Manage01.jsp").forward(req, res);
		}catch(Exception ex){
			ex.printStackTrace();
			throw new ServletException(ex);
		}finally{
			close();
		}
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws IOException, ServletException
	{
		doGet(req, res);
	}
}
