package member2;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.LinkedList;
import java.util.List;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Delete02back extends HttpServlet {
	Connection co;

	private void getConnection() throws Exception {
		ResourceBundle rb = ResourceBundle.getBundle("postgresql");
		Class.forName(rb.getString("driver"));
		String jdbc = rb.getString("jdbc");
		String dtbs = rb.getString("dtbs");
		String user = rb.getString("user");
		String pass = rb.getString("pass");
		co = DriverManager.getConnection(jdbc + dtbs, user, pass);
	}

	private void close(){
		try{
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		try{
			if(req.getParameter("check") != null){
				req.getRequestDispatcher("/jstl/Param02.jsp").forward(req, res);
			}else{
				getConnection();
				String sql = "delete from memberlist where id=?";
				PreparedStatement ps = co.prepareStatement(sql);
				String[] delinfo = req.getParameterValues("delinfo");
				if(delinfo != null){
					for(int i = 0; i < delinfo.length; i++){
						ps.setInt(1, Integer.parseInt(delinfo[i]));
						ps.executeUpdate();
					}
				}
				sql = "select * from memberlist";
				ps = co.prepareStatement(sql);
				ResultSet rs = ps.executeQuery();
				List ll = new LinkedList();
				while(rs.next()){
					String[] row = new String[5];
					row[0] = rs.getString("id");
					row[1] = rs.getString("name");
					row[2] = rs.getInt("gender") == 1 ? "男" : "女";
					row[3] = rs.getString("tel");
					row[4] = rs.getString("email");
					ll.add(row);
				}
				req.setAttribute("memberlist", ll);
				req.getRequestDispatcher("/member2/Delete02.jsp").forward(req, res);
			}
		}catch(Exception ex){
			ex.printStackTrace();
			throw new ServletException(ex);
		}finally{
			close();
		}
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		doGet(req, res);
	}
}
