package ticket2;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.LinkedList;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Record01 extends HttpServlet {
	Connection co;

	private void getConnection() throws Exception {
		ResourceBundle rb = ResourceBundle.getBundle("postgresql");
		Class.forName(rb.getString("driver"));
		String jdbc = rb.getString("jdbc");
		String dtbs = rb.getString("dtbs");
		String user = rb.getString("user");
		String pass = rb.getString("pass");
		co = DriverManager.getConnection(jdbc + dtbs, user, pass);
	}

	private void close(){
		try{
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		try {
			getConnection();
			String sql = "select * from ticketorder";
			PreparedStatement ps = co.prepareStatement(sql);
			ResultSet rs = ps.executeQuery();
			LinkedList<String[]> ll = new LinkedList<String[]>();
			while(rs.next()){
				String[] row = {
					rs.getString("ordertime"),
					rs.getString("lpic"),
					rs.getString("sjcp"),
					rs.getString("psql"),
					rs.getString("totalprice")
				};
				ll.add(row);
			}
			req.setAttribute("orderrec", ll);
		} catch (Exception ex) {
			throw new ServletException(ex);
		}finally{
			close();
		}
		req.getRequestDispatcher("/ticket2/Record01.jsp").forward(req, res);
	}
}
