package ticket2;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class Serv01 extends HttpServlet {
	Connection co;

	private void getConnection() throws Exception {
		ResourceBundle rb = ResourceBundle.getBundle("postgresql");
		Class.forName(rb.getString("driver"));
		String jdbc = rb.getString("jdbc");
		String dtbs = rb.getString("dtbs");
		String user = rb.getString("user");
		String pass = rb.getString("pass");
		co = DriverManager.getConnection(jdbc + dtbs, user, pass);
	}

	private void close(){
		try{
			co.close();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}

	@Override
	public void doGet(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		HttpSession ses = req.getSession();
		Cart01 cart = (Cart01)ses.getAttribute("ticketcart2");
		if(cart == null){
			cart = new Cart01();
			ses.setAttribute("ticketcart2", cart);
		}

		String ope = req.getParameter("ope");
		if(ope.equals("set")){
			cart.addLpic(Integer.parseInt(req.getParameter("lpic")));
			cart.addSjcp(Integer.parseInt(req.getParameter("sjcp")));
			cart.addPsql(Integer.parseInt(req.getParameter("psql")));
			res.sendRedirect("/jmwapp/ticket2/Show01.jsp");
		}else if(ope.equals("order")){
			try {
				getConnection();
				String sql;
				sql = "insert into ticketorder(lpic,sjcp,psql,totalprice) values(?,?,?,?)";
				PreparedStatement ps = co.prepareStatement(sql);
				ps.setInt(1, cart.getLpic());
				ps.setInt(2, cart.getSjcp());
				ps.setInt(3, cart.getPsql());
				ps.setInt(4, cart.getTotalPrice());
				ps.executeUpdate();
			} catch (Exception ex) {
				throw new ServletException(ex);
			}finally{
				close();
			}
			cart.clear();
			res.sendRedirect("/jmwapp/ticket2/Thank01.html");
		}else if(ope.equals("clear")){
			cart.clear();
			res.sendRedirect("/jmwapp/ticket2/Show01.jsp");
		}
	}

	@Override
	public void doPost(HttpServletRequest req, HttpServletResponse res)
		throws IOException, ServletException
	{
		doGet(req, res);
	}
}
